.Const

.Data

MESSAGES	DD WM_CREATE, OnCreate
			DD WM_COMMAND, OnCommand
			DD WM_CLOSE, OnClose

szBuffer	DB	32 Dup 0

lCount1		DD	0
lCount2		DD	0
uTimer1		DD	0
uTimer2		DD	0


.Code

TestGoAsmProcedure Frame hWnd, uMsg, wParam, lParam
	Mov Eax, [uMsg]
	Mov Ecx, SizeOf MESSAGES / 8
	Mov Edx, Addr MESSAGES
:	Dec Ecx
	Js >L2
	Cmp [Edx + Ecx * 8], Eax
	Jne <
	Call [Edx + Ecx * 8 + 4]
	Ret
L2:	Return (FALSE)
EndF

OnCreate:
	UseData TestGoAsmProcedure
	;==================================
	;Write the initialization code here
	;==================================
	Return (TRUE)
EndU

OnCommand:
	UseData TestGoAsmProcedure
	LoWord ([wParam])
	Cmp Ax, IDC_TESTGOASM_BUTTON1
	Jne > L2
	HiWord ([wParam])
	Cmp Ax, BN_CLICKED
	Jne > L2
	Mov Eax, [uTimer1]
	Or Eax, [uTimer2]
	Jz >
	Call StopTimers
	Return (TRUE)
:	Invoke BeginTimer, 10, Addr TimerProcedure
	Mov [uTimer1], Eax
	Invoke BeginTimer, 100, Addr TimerProcedure
	Mov [uTimer2], Eax
	Invoke SetButtonText, TEXT("Stop timer")
	Return (TRUE)
L2:	Xor Eax, Eax
	Ret
EndU

OnClose:
	UseData TestGoAsmProcedure
	;=========================
	;Write the final code here
	;=========================
	Invoke IsModal, [hWnd]
	Or Eax, Eax		;Cmp Eax, FALSE
	Jz >
	Invoke EndModal, [hWnd], IDCANCEL
	Mov Eax, TRUE	;Return (TRUE)
:	Ret
EndU

SetButtonText Frame lpszText
	Invoke GetWindowItem, [App.Main], IDC_TESTGOASM_BUTTON1
	Invoke SetWindowText, Eax, [lpszText]
	Ret
EndF

StopTimers:
	Cmp D[uTimer1], 0
	Je >
	Invoke EndTimer, [uTimer1]
	Mov D[lCount1], 0
	Mov D[uTimer1], 0
:	Cmp D[uTimer2], 0
	Je >
	Invoke EndTimer, [uTimer2]
	Mov D[lCount2], 0
	Mov D[uTimer2], 0
	Invoke SetButtonText, TEXT("Start timer")
:	Ret

TimerProcedure Frame uID
	Mov Eax, [uID]
	Cmp Eax, [uTimer1]
	Jne >
	Invoke String, [lCount1], Addr szBuffer, ecDecimal
	Invoke GetWindowItem, [App.Main], IDC_TESTGOASM_STATIC1
	Inc D[lCount1]
	Jmp > L2
:	Invoke String, [lCount2], Addr szBuffer, ecDecimal
	Invoke GetWindowItem, [App.Main], IDC_TESTGOASM_STATIC2
	Inc D[lCount2]
L2:	Invoke SetWindowText, Eax, Addr szBuffer
	Ret
EndF
